From 4ea5f5d5cf295701f2765ff953338f8cc6b3b956 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Hugo=20Beauz=C3=A9e-Luyssen?= <beauze.h@gmail.com>
Date: Thu, 24 Nov 2011 16:21:19 +0100
Subject: [PATCH 10/10] dash: Removing EOFException

---
 modules/stream_filter/dash/DASHManager.cpp         |   18 +-------
 modules/stream_filter/dash/DASHManager.h           |    1 -
 .../adaptationlogic/AbstractAdaptationLogic.cpp    |    1 -
 .../dash/adaptationlogic/AbstractAdaptationLogic.h |    3 +-
 .../adaptationlogic/AlwaysBestAdaptationLogic.cpp  |   11 ++---
 .../adaptationlogic/AlwaysBestAdaptationLogic.h    |    3 +-
 .../dash/adaptationlogic/IAdaptationLogic.h        |    3 +-
 .../dash/adaptationlogic/NullAdaptationLogic.h     |    3 +-
 .../adaptationlogic/RateBasedAdaptationLogic.cpp   |   12 ++----
 .../adaptationlogic/RateBasedAdaptationLogic.h     |    3 +-
 .../stream_filter/dash/exceptions/EOFException.h   |   42 --------------------
 11 files changed, 16 insertions(+), 84 deletions(-)
 delete mode 100644 modules/stream_filter/dash/exceptions/EOFException.h

diff --git a/modules/stream_filter/dash/DASHManager.cpp b/modules/stream_filter/dash/DASHManager.cpp
index aa4e8fb..73bd448 100644
--- a/modules/stream_filter/dash/DASHManager.cpp
+++ b/modules/stream_filter/dash/DASHManager.cpp
@@ -32,7 +32,6 @@ using namespace dash::http;
 using namespace dash::xml;
 using namespace dash::logic;
 using namespace dash::mpd;
-using namespace dash::exception;
 
 DASHManager::DASHManager    (HTTPConnectionManager *conManager, Node *node, IAdaptationLogic::LogicType type, Profile profile)
 {
@@ -55,15 +54,8 @@ int DASHManager::read   (void *p_buffer, size_t len)
 {
     if(this->currentChunk == NULL)
     {
-        try
-        {
-            this->currentChunk = this->adaptationLogic->getNextChunk();
-        }
-        catch(EOFException &e)
-        {
-            this->currentChunk = NULL;
+        if ( ( this->currentChunk = this->adaptationLogic->getNextChunk() ) == NULL )
             return 0;
-        }
     }
 
     int ret = this->conManager->read(this->currentChunk, p_buffer, len);
@@ -80,14 +72,8 @@ int DASHManager::peek   (const uint8_t **pp_peek, size_t i_peek)
 {
     if(this->currentChunk == NULL)
     {
-        try
-        {
-            this->currentChunk = this->adaptationLogic->getNextChunk();
-        }
-        catch(EOFException &e)
-        {
+        if ( ( this->currentChunk = this->adaptationLogic->getNextChunk() ) == NULL )
             return 0;
-        }
     }
 
     int ret = this->conManager->peek(this->currentChunk, pp_peek, i_peek);
diff --git a/modules/stream_filter/dash/DASHManager.h b/modules/stream_filter/dash/DASHManager.h
index a9affcb..d14d111 100644
--- a/modules/stream_filter/dash/DASHManager.h
+++ b/modules/stream_filter/dash/DASHManager.h
@@ -31,7 +31,6 @@
 #include "adaptationlogic/AdaptationLogicFactory.h"
 #include "mpd/IMPDManager.h"
 #include "mpd/MPDManagerFactory.h"
-#include "exceptions/EOFException.h"
 
 namespace dash
 {
diff --git a/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.cpp b/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.cpp
index 5a5c1bc..c61a8d7 100644
--- a/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.cpp
+++ b/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.cpp
@@ -30,7 +30,6 @@
 using namespace dash::logic;
 using namespace dash::xml;
 using namespace dash::mpd;
-using namespace dash::exception;
 
 AbstractAdaptationLogic::AbstractAdaptationLogic    (IMPDManager *mpdManager)
 {
diff --git a/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.h b/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.h
index d66c0dc..eec3dd3 100644
--- a/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.h
+++ b/modules/stream_filter/dash/adaptationlogic/AbstractAdaptationLogic.h
@@ -35,7 +35,6 @@
 #include "mpd/InitSegment.h"
 #include "mpd/Segment.h"
 #include "exceptions/AttributeNotPresentException.h"
-#include "exceptions/EOFException.h"
 
 namespace dash
 {
@@ -47,7 +46,7 @@ namespace dash
                 AbstractAdaptationLogic             (dash::mpd::IMPDManager *mpdManager);
                 virtual ~AbstractAdaptationLogic    ();
 
-                virtual dash::http::Chunk*  getNextChunk            () throw(dash::exception::EOFException) = 0;
+                virtual dash::http::Chunk*  getNextChunk            () = 0;
                 virtual void                downloadRateChanged     (long bpsAvg, long bpsLastChunk);
 
                 long                        getBpsAvg               ();
diff --git a/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.cpp b/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.cpp
index c9708a9..53c6a1d 100644
--- a/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.cpp
+++ b/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.cpp
@@ -31,7 +31,6 @@ using namespace dash::logic;
 using namespace dash::xml;
 using namespace dash::http;
 using namespace dash::mpd;
-using namespace dash::exception;
 
 AlwaysBestAdaptationLogic::AlwaysBestAdaptationLogic    (IMPDManager *mpdManager) : AbstractAdaptationLogic(mpdManager)
 {
@@ -43,13 +42,13 @@ AlwaysBestAdaptationLogic::~AlwaysBestAdaptationLogic   ()
 {
 }
 
-Chunk*  AlwaysBestAdaptationLogic::getNextChunk () throw(EOFException)
+Chunk*  AlwaysBestAdaptationLogic::getNextChunk ()
 {
-    if(this->schedule.size() == 0)
-        throw EOFException();
+    if ( this->schedule.size() == 0)
+        return NULL;
 
-    if(this->count == this->schedule.size())
-        throw EOFException();
+    if ( this->count == this->schedule.size() )
+        return NULL;
 
     for(size_t i = 0; i < this->schedule.size(); i++)
     {
diff --git a/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.h b/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.h
index 6c07d05..8401cd9 100644
--- a/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.h
+++ b/modules/stream_filter/dash/adaptationlogic/AlwaysBestAdaptationLogic.h
@@ -31,7 +31,6 @@
 #include "mpd/IMPDManager.h"
 #include "mpd/Period.h"
 #include "mpd/Segment.h"
-#include "exceptions/EOFException.h"
 #include "mpd/BasicCMManager.h"
 #include "mpd/ISegment.h"
 #include <vector>
@@ -46,7 +45,7 @@ namespace dash
                 AlwaysBestAdaptationLogic           (dash::mpd::IMPDManager *mpdManager);
                 virtual ~AlwaysBestAdaptationLogic  ();
 
-                dash::http::Chunk* getNextChunk () throw(dash::exception::EOFException);
+                dash::http::Chunk* getNextChunk ();
 
             private:
                 std::vector<dash::mpd::ISegment *>  schedule;
diff --git a/modules/stream_filter/dash/adaptationlogic/IAdaptationLogic.h b/modules/stream_filter/dash/adaptationlogic/IAdaptationLogic.h
index ef38604..a1ccbdc 100644
--- a/modules/stream_filter/dash/adaptationlogic/IAdaptationLogic.h
+++ b/modules/stream_filter/dash/adaptationlogic/IAdaptationLogic.h
@@ -27,7 +27,6 @@
 
 #include <http/Chunk.h>
 #include <adaptationlogic/IDownloadRateObserver.h>
-#include <exceptions/EOFException.h>
 
 namespace dash
 {
@@ -45,7 +44,7 @@ namespace dash
                     RateBased,
                 };
 
-                virtual dash::http::Chunk* getNextChunk() throw(dash::exception::EOFException) = 0;
+                virtual dash::http::Chunk* getNextChunk() = 0;
 
         };
     }
diff --git a/modules/stream_filter/dash/adaptationlogic/NullAdaptationLogic.h b/modules/stream_filter/dash/adaptationlogic/NullAdaptationLogic.h
index a5e88ed..285b5a8 100644
--- a/modules/stream_filter/dash/adaptationlogic/NullAdaptationLogic.h
+++ b/modules/stream_filter/dash/adaptationlogic/NullAdaptationLogic.h
@@ -29,7 +29,6 @@
 #include "http/Chunk.h"
 #include "xml/Node.h"
 #include "mpd/IMPDManager.h"
-#include "exceptions/EOFException.h"
 
 namespace dash
 {
@@ -41,7 +40,7 @@ namespace dash
                 NullAdaptationLogic         (dash::mpd::IMPDManager *mpdManager) : AbstractAdaptationLogic(mpdManager)  {}
                 virtual ~NullAdaptationLogic()                                                                          {}
 
-                dash::http::Chunk* getNextChunk () throw(dash::exception::EOFException) { throw dash::exception::EOFException(); }
+                dash::http::Chunk* getNextChunk () { return NULL; }
         };
     }
 }
diff --git a/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.cpp b/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.cpp
index 498c7df..c3ca393 100644
--- a/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.cpp
+++ b/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.cpp
@@ -31,7 +31,6 @@ using namespace dash::logic;
 using namespace dash::xml;
 using namespace dash::http;
 using namespace dash::mpd;
-using namespace dash::exception;
 
 RateBasedAdaptationLogic::RateBasedAdaptationLogic  (IMPDManager *mpdManager) : AbstractAdaptationLogic(mpdManager)
 {
@@ -43,20 +42,17 @@ RateBasedAdaptationLogic::~RateBasedAdaptationLogic ()
 {
 }
 
-Chunk*  RateBasedAdaptationLogic::getNextChunk () throw(EOFException)
+Chunk*  RateBasedAdaptationLogic::getNextChunk ()
 {
-    if(this->mpdManager == NULL)
-        throw EOFException();
-
-    if(this->currentPeriod == NULL)
-        throw EOFException();
+    if ( this->mpdManager == NULL || this->currentPeriod == NULL )
+        return NULL;
 
     long bitrate = this->getBpsAvg();
 
     Representation *rep = this->mpdManager->getRepresentation(this->currentPeriod, bitrate);
 
     if(rep == NULL)
-        throw EOFException();
+        return NULL;
 
     std::vector<ISegment *> segments = this->mpdManager->getSegments(rep);
 
diff --git a/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.h b/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.h
index 8337922..f00f574 100644
--- a/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.h
+++ b/modules/stream_filter/dash/adaptationlogic/RateBasedAdaptationLogic.h
@@ -29,7 +29,6 @@
 #include "xml/Node.h"
 #include "mpd/IMPDManager.h"
 #include "http/Chunk.h"
-#include "exceptions/EOFException.h"
 #include "mpd/BasicCMManager.h"
 
 namespace dash
@@ -42,7 +41,7 @@ namespace dash
                 RateBasedAdaptationLogic            (dash::mpd::IMPDManager *mpdManager);
                 virtual ~RateBasedAdaptationLogic   ();
 
-                dash::http::Chunk* getNextChunk () throw(dash::exception::EOFException);
+                dash::http::Chunk* getNextChunk ();
 
             private:
                 dash::mpd::IMPDManager  *mpdManager;
diff --git a/modules/stream_filter/dash/exceptions/EOFException.h b/modules/stream_filter/dash/exceptions/EOFException.h
deleted file mode 100644
index 06a95d1..0000000
--- a/modules/stream_filter/dash/exceptions/EOFException.h
+++ /dev/null
@@ -1,42 +0,0 @@
-/*
- * EOFException.h
- *****************************************************************************
- * Copyright (C) 2010 - 2011 Klagenfurt University
- *
- * Created on: Aug 10, 2010
- * Authors: Christopher Mueller <christopher.mueller@itec.uni-klu.ac.at>
- *          Christian Timmerer  <christian.timmerer@itec.uni-klu.ac.at>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2.1 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
- *****************************************************************************/
-
-#ifndef EOFEXCEPTION_H_
-#define EOFEXCEPTION_H_
-
-#include <stdexcept>
-
-namespace dash
-{
-    namespace exception
-    {
-        class EOFException : public std::exception
-        {
-            public:
-                EOFException() : std::exception() {}
-        };
-    }
-}
-
-#endif /* EOFEXCEPTION_H_ */
-- 
1.7.7.4

